unit TeleComportUnit;

{$define COMPONENTALONE}

interface

uses CPort, Dialogs, SysUtils, Forms, Classes, Windows, DateUtils, Messages,
  Registry;

type

  TTeleReadEvent =
    procedure(Sender: TObject; s: string; t: TDateTime; DevID: string) of object;
  TTelePressEvent =
    procedure(Sender: TObject; Key: Char; DevID: string) of object;
  TTeleWaveinEvent =
    procedure(Sender: TObject; wavestring,DevID: string) of object;

  TReData = record //豸ݰʽ
    dlength: Integer;
    dtype: char;
    ddata: string[100];
  end;


{
  TUsbTeleThread = class(TThread)
  private
    hMsg: THandle;
  protected
    procedure Execute; override;
  public
    constructor Create(AHandle: THandle);
  end;
}

  TTeleComport = class(TCustomComPort)
//  TTeleComport = class(TComPort)
  private
    { Private declarations }
    lastst: string;
    FTeleNo: string;
    FTeleTime: TDateTime;
    FDevid: string;
    FPortID: string;
    FOnOpen: TNotifyEvent;
    FOnClose: TNotifyEvent;
    FOnRead: TTeleReadEvent;
    FOnKeyPress: TTelePressEvent;
    FOnWavein:   TTeleWaveinEvent;
    FJDConnected: Boolean;
    FJDUsbdevCount: Integer;
    Fiswavedev: Boolean;
    FWindowHandle: THandle;
    LastComTime: TDateTime;
    function ShowTeleNo: Boolean;
    procedure ackpack;
    procedure OpenUSB(Sender: TObject);
    procedure CloseUSB(Sender: TObject);
    procedure SetJDConnected(const Value: Boolean);
    procedure GetDevIDFrom(const cst: string);
    procedure ReopenUSB(Sender: TObject);
  protected
    procedure DoRxChar(Count: Integer); override;
  public
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;
    procedure Open; dynamic;
    procedure Close; dynamic;
    function SetupPort: Boolean; overload;
    function SetupPorts(var ports: String): Boolean;
    function LineStatus(const lineno: Integer=1): Integer;
    function EraseAll: Integer;
    function RecordsCount: Integer;
    function ReadAllRecords: Integer;
    procedure ReadAllWhenOpen;
    function ReadDevID(var devid: Integer): Integer;
    function ReadDevVer(var dver: string): Integer;
    function Dialup(const telno: string): Integer;
    procedure DoPressKey;
    procedure DoTelerportEvent;
    function Dialupchanl(const telno: string; chanl:Integer=1): Integer;
    procedure writestrtojd2000(const st: string);
    function readfromjd2000(var st: string): Integer;
    procedure SetHandup(const ishandup: Integer; const chanl: Integer=1);
    function ReadSysTelNo(const syskeyno: Integer=1): string;
    function SetSysTelNo(const teleno: string;
              const syskeyno: Integer; const chanl: Integer=1): Integer;
    procedure Startwavein(const chanl: Integer=1);
    procedure Stopwavein(const chanl: Integer=1);

  published
    property BaudRate;
    property Port;
    property Parity;
    property StopBits;
    property DataBits;
    //property DiscardNull;
    //property EventChar;
    //property Events;
    //property Buffer;
    //property FlowControl;
    //property Timeouts;
    //property SyncMethod;
    //property OnAfterOpen;
    //property OnAfterClose;
    //property OnBeforeOpen;
    //property OnBeforeClose;
    //property OnRxChar;
    //property OnRxBuf;
    //property Connected;
    property OnOpen: TNotifyEvent read FOnOpen write FOnOpen;
    property OnClose: TNotifyEvent read FOnClose write FOnClose;
    property OnRead: TTeleReadEvent read FOnRead write FOnRead;
    property OnKeyPress: TTelePressEvent read FOnKeyPress write FOnKeyPress;
    property OnWavein: TTeleWaveinEvent read FOnWavein write FOnWavein;
    property JDConnected: Boolean read FJDConnected write SetJDConnected;
    property JDUsbdevCount: Integer read FJDUsbdevCount;// write SetJDConnected;
    property iswavedev: Boolean read Fiswavedev write Fiswavedev;
  end;

procedure Register;


implementation

uses ch375dll, TelePortSet, USBunit;

const
  PACKETSTART=#$FF#$55#$AA#$FF;
  PACKETHEAD =#$FF#$55#$AA#0;
  DATARESPONSE      =$E2;
  MAXDEVCOUNT =10;


  CM_EARSEALLDATA   =$DF; //
    //     0 ɹ  0xFFʧ

  CM_READDEVID      =$DA; //ȡ豸
    //     豸 1ֽڣ

  CM_READVER        =$D8; //ȡ汾
    //     汾 1ֽڣ

  CM_READSTATE      =$D7; //ȡϵͳ״̬
    //     ϵͳ״̬ ṹ
    //         autoseve:   Byte  //Զ浱ֵΪ0ʱԶ Ĭֵ:0xFF
    //         deviceid:   Byte  //豸IDţ1-255  Ĭֵ:0xFF Ϊ0

  CM_WRITESTATE     =$D6; //趨ϵͳ״̬
    //    ʱ ϵͳ״̬ ṹͬ
    //     0 ɹ  0xFFʧ

  CM_READNEWRECORDER=$D3; //ȡȫ¼¼
    //     ȫ¼¼ (ƽʱ⵽CIDʱͳַͬȺ˳ͳ
    //    󷵻0; ֱӷ0ʾ¼¼

  CM_NEWRECORDERCOUNT=$D2; //ȡ¼¼
    //     ¼¼ ˫ֽ λǰ λں

  CM_DIALUP          =$D1; // 绰
    //     0 Ųųɹ ʧ

  CM_LINESTATUS      =$D0; //ȡ绰״̬
    //     0 в Բ
  CM_DIALUPCHANL     =$CF; //  ·(1λ)+绰
    //     0 Ųųɹ ʧ
  CM_SETWAVEIN       =$CB; //ʼֹͣ  1λ 0 ֹͣ 1ʼ

var
  hasflash: Boolean;
  comstr,restr: string;
  //usbTrigger: Boolean;
  Ateleobj:TTeleComport;
  //mProc: array of procedure(mbuffer:pbytearray); stdcall;//TiIntRoutine;
  reda: TReData;
  chsta: Integer;

procedure Register;
begin
  RegisterComponents('kosenTools', [TTeleComport]);
end;

function StrToHex(const str: string): string;
var
  i: Integer;
  ss: string;
begin
  ss:='';
  for i:=1 to Length(str) do
    ss:=ss+IntToHex(Ord(str[i]),2)+' ';
  Result:=ss;
end;
{$ifdef COMPONENTALONE}

procedure GetAllComPort(ts: TStrings);
var
  rt: TRegistry;
  i: Integer;
begin
  rt:=TRegistry.Create;
  with rt do
  try
    RootKey:=HKEY_LOCAL_MACHINE;
    OpenKey('HARDWARE\DEVICEMAP\SERIALCOMM',False);
    GetValueNames(ts);
    for i:=0 to ts.Count-1 do
      ts[i]:=ReadString(ts[i]);
  finally
    Free;
  end;
end;

function PortExists(sport: String): Boolean;
var
  ts: TStrings;
  i: Integer;
begin
  Result:=False;
  ts:=TStringList.Create;
  try
    GetAllComPort(ts);
    for i:=0 to ts.Count-1 do
      if AnsiCompareText(sport,ts[i])=0 then
      begin
        Result:=True;
        Break;
      end;
  finally
    ts.Free;
  end;
end;
{$endif}

function StartPos(const str: string): Integer;
var
  i: Integer;
  tst: string[8];
const
  startchar1=#$55#$55#$55#$55#$55#$55#$04;
  startchar2=#$55#$55#$55#$55#$55#$55#$80;
begin
  result:=0;
  for i:=1 to Length(str)-6 do
  begin
    tst:=Copy(str,i,7);
    tst[6]:=char(ord(tst[6]) and $55);
    if (tst=startchar1) or (tst=startchar2) then
    begin
      Result:=i;
      break;
    end;
  end;
end;


function gstcommstr(const cst: string): string;
var
  ch,l: Integer;
  b:Byte;
begin
  l:=Length(cst);
  b:=l;
  for ch:=1 to l do
    b:=b+ord(cst[ch]);
  b:=0-b;
  result:=#$FF#$55#$AA#$FF+char(l)+cst+char(b);
end;

procedure getachpack(lch: char);  //ȡ
var
  n: Integer;
  csum: Byte;
begin
  case chsta of
    0:   //ʼ֡ĵ1ֽ
      if lch=#$FF then chsta:=1;
    1:   //ʼ֡ĵ2ֽ
      if lch=#$55 then
        chsta:=2
      else if lch=#$FF then
        chsta:=1
      else
        chsta:=0;
    2:   //ʼ֡ĵ4ֽ
      if lch=#$AA then
        chsta:=3
      else
        chsta:=0;
    3:   //ݰĿַ
      if lch=#$00 then
        chsta:=4
      else
        chsta:=0;
    4:   //ݰ
    begin
      chsta:=5;
      reda.dlength:=ord(lch);
    end;

    5://ݰ
    begin
      chsta:=6;
      with reda do begin
        dtype:=lch;
        ddata:='';
        if dlength=1 then chsta:=7;
      end;
    end;
    6:   //ݰ
    begin
      n:=Length(reda.ddata);
      if (n<100) and (n<reda.dlength-1) then
        reda.ddata:=reda.ddata+lch;
      if (n+2)=reda.dlength then
        chsta:=7;

    end;
    7:  //У
    begin
      chsta:=8;
      if (lch=#10) then  chsta:=9
      else begin
        csum:=reda.dlength+ord(reda.dtype);
        for n:=1 to length(reda.ddata) do
          csum:=csum+ord(reda.ddata[n]);
        csum:=0-csum;
        if (lch=char(csum)) then chsta:=9;
      end;
    end
  end;
end;



function getreturnsta(const delay: Integer;const step: Integer=1): Boolean;
var
  i,n: Integer;
  st: string;
const
  CRESTR=#$FF#$55#$AA#$00#$01#$00#$FF;
begin
  Result:=False;
  st:='';
  for i:=1 to delay do begin
    Application.ProcessMessages;
    st:=restr;
    n:=pos(CRESTR,st);
    if (n>0) then   begin
      Result:=True;
      Exit;
    end;
    sleep(step);
  end;
end;



function GetCIDString(var instr,tstr: string): Boolean;
var
  str: string;
  n,l,k: integer;
  stp: string;
begin
  Result:=False;
  if instr='' then Exit;
  stp:=instr;
  n:=StartPos(instr);
  if n=0 then begin
    if instr[1]=#$80 then
    begin
      str:=instr;
      k:=0;
    end
    else
      Exit;
  end
  else begin
    str:=copy(instr,n+6,255);
    k:=n+6;
  end;
  l:=Length(str);
  if (l<8) then Exit;
  n:=ord(str[2]);//Ϣܳ
  if (l<(n+3)) then Exit;
  str:=Copy(str,1,n+3);
  k:=k+n+3;
  instr:=copy(instr,k,255);
  tstr:=str;
  Result:=True;
end;


function divitemofstring(var instr,ostr: string):Boolean;
var
  ch: Char;
  no,dstr,ns: string;
  l:Integer;

  function istoolshort: Boolean;
  begin
    if Length(instr)<3 then
    begin
      instr:='';
      Result:=True;
    end
    else
      Result:=False;
  end;

begin
  ch:=instr[1];
  Result:=False;
  ostr:='';
  if not ((ch=#$80) or (ch=#$04)) then Exit;
  no:='';dstr:='';ns:='';
  if ch=#$04 then
  begin
    l:=ord(instr[2]);
    dstr:=Copy(instr,3,8);
    no:=Copy(instr,11,l-8);
    instr:=Copy(instr,l+3,1024);
  end
  else
  while instr>'' do begin
    if istoolshort then break;
    ch:=instr[1];
    l:=ord(instr[2]);
    case ch of
      #$01:   //ʱ        8λ
      begin
        dstr:=Copy(instr,3,l);
      end;
      #$02:    //ʶ   20λ
      begin
        no:=Copy(instr,3,l);
      end;
      #$03:    //ʶ   20λ
      begin
      end;
      #$04:    //ʶԭ  1λ  'C'Ͷ 'I'  'O'޺ 'P'˽
      begin
        no:=Copy(instr,3,l);
      end;
      #$05:    //
      begin
      end;
      #$06:    //
      begin
      end;
      #$07:    //
      begin
        ns:=Copy(instr,3,l);
      end;
      #$08:    //
      begin
        ns:=Copy(instr,3,l);
      end;
      #$09:    //
      begin
      end;
      #$0A:    //
      begin
      end;
      #$0B:    //ָʾ       1λ
      begin
      end;
      #$0C:    //
      begin
      end;
      #$0D:    //
      begin
      end;
      #$0E:    //
      begin
      end;
      #$0F:    //
      begin
      end;
      #$10:    //
      begin
      end;
      #$11:    //ʽ
      begin
      end;
      #$12:    //һʶ
      begin
      end;
      #$13:    //Ϣ״
      begin
      end;
      #$15:    //תӵ绰ʽ
      begin
      end;
      #$16:    //ûʽ
      begin
      end;
      #$1A:    //תӵ绰ʽ
      begin
      end;
      #$80:    //תӵ绰ʽ
      begin
        l:=0
      end;
    end;
    instr:=Copy(instr,3+l,1024);
  end;
  Result:=True;
  if no='' then no:=ns;
  if no='' then no:='Unknown';
//  ostr:=Format('Date=%-8s Telno=%-20s Name=%-20s',[dstr,no,ns]);
  ostr:=Format('%-8s%-20s%-20s',[dstr,no,ns]);
end;


//USB豸ݴ͵PCñģ
procedure ExecInterruptEvent(mIndex: SmallInt; mBuffer: pbytearray);stdcall;
var
  mlength: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
  cdid: string;
begin
  mlength:=mBuffer[0];
  CH375ReadData(mIndex, @buff, @mlength);
  if mlength=0 then Exit;
  str:='';
  if (devid[mIndex]>9) or (devid[mIndex]<1) then
    cdid:='&1'
  else
    cdid:='&'+IntToStr(devid[mIndex]);
  for i:=0 to mlength-1 do
  begin
    case buff[i] of
    $25,$40:    //'@' '%'
      str:=str+cdid+char(buff[i]);
    else
      str:=str+char(buff[i]);
    end;
  end;
//  comstr:=comstr+str;
  comstr:=str;
  Ateleobj.DoTelerportEvent;
end;

procedure mInterruptEvent0(mBuffer: pbytearray);stdcall;
begin
  ExecInterruptEvent(0, mBuffer);
end;

procedure mInterruptEvent1(mBuffer: pbytearray);stdcall;
begin
  ExecInterruptEvent(1, mBuffer);
end;
procedure mInterruptEvent2(mBuffer: pbytearray);stdcall;
begin
  ExecInterruptEvent(2,mBuffer);
end;

procedure mInterruptEvent3(mBuffer: pbytearray);stdcall;
begin
  ExecInterruptEvent(3, mBuffer);
end;
procedure mInterruptEvent4(mBuffer: pbytearray);stdcall;
begin
  ExecInterruptEvent(4,mBuffer);
end;
procedure mInterruptEvent5(mBuffer: pbytearray);stdcall;
begin
  ExecInterruptEvent(5,mBuffer);
end;
procedure mInterruptEvent6(mBuffer: pbytearray);stdcall;
begin
  ExecInterruptEvent(6,mBuffer);
end;
procedure mInterruptEvent7(mBuffer: pbytearray);stdcall;
begin
  ExecInterruptEvent(7,mBuffer);
end;

procedure mCallInt(const devno: Integer) ;
var
  mm: TiIntRoutine;
begin
  case devno of
    0: mm:=mInterruptEvent0;
    1: mm:=mInterruptEvent1;
    2: mm:=mInterruptEvent2;
    3: mm:=mInterruptEvent3;
    4: mm:=mInterruptEvent4;
    5: mm:=mInterruptEvent5;
    6: mm:=mInterruptEvent6;
    7: mm:=mInterruptEvent7;
    else Exit;
  end;
  if not CH375SetIntRoutine(devno, mm) then    //жӳ
    Showmessage(''+IntToStr(devno)+'USB豸޷ж');
end;

{
procedure mInterruptEvent0(mBuffer:pbytearray );stdcall;
var
  mlength,mIndex: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
begin
  mlength:=mBuffer[0];
  mIndex:=0;
  CH375ReadData(mIndex,@buff,@mlength);
  str:='';
  for i:=0 to mlength-1 do
    str:=str+char(buff[i]);
  comstr:=comstr+str;
  i:=Length(comstr);
  if i>255 then Delete(comstr,1,i-240);
  usbTrigger:=True;
end;

procedure mInterruptEvent1(mBuffer:pbytearray );stdcall;
var
  mlength,mIndex: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
begin
  mlength:=mBuffer[0];
  mIndex:=1;
  CH375ReadData(mIndex,@buff,@mlength);
  str:='';
  for i:=0 to mlength-1 do
    str:=str+char(buff[i]);
  comstr:=comstr+str;
  i:=Length(comstr);
  if i>255 then Delete(comstr,1,i-240);
  usbTrigger:=True;
end;

procedure mInterruptEvent2(mBuffer:pbytearray );stdcall;
var
  mlength,mIndex: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
begin
  mlength:=mBuffer[0];
  mIndex:=2;
  CH375ReadData(mIndex,@buff,@mlength);
  str:='';
  for i:=0 to mlength-1 do
    str:=str+char(buff[i]);
  comstr:=comstr+str;
  i:=Length(comstr);
  if i>255 then Delete(comstr,1,i-240);
  usbTrigger:=True;
end;

procedure mInterruptEvent3(mBuffer:pbytearray );stdcall;
var
  mlength,mIndex: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
begin
  mlength:=mBuffer[0];
  mIndex:=3;
  CH375ReadData(mIndex,@buff,@mlength);
  str:='';
  for i:=0 to mlength-1 do
    str:=str+char(buff[i]);
  comstr:=comstr+str;
  i:=Length(comstr);
  if i>255 then Delete(comstr,1,i-240);
  usbTrigger:=True;
end;

procedure mInterruptEvent4(mBuffer:pbytearray );stdcall;
var
  mlength,mIndex: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
begin
  mlength:=mBuffer[0];
  mIndex:=4;
  CH375ReadData(mIndex,@buff,@mlength);
  str:='';
  for i:=0 to mlength-1 do
    str:=str+char(buff[i]);
  comstr:=comstr+str;
  i:=Length(comstr);
  if i>255 then Delete(comstr,1,i-240);
  usbTrigger:=True;
end;

procedure mInterruptEvent5(mBuffer:pbytearray );stdcall;
var
  mlength,mIndex: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
begin
  mlength:=mBuffer[0];
  mIndex:=5;
  CH375ReadData(mIndex,@buff,@mlength);
  str:='';
  for i:=0 to mlength-1 do
    str:=str+char(buff[i]);
  comstr:=comstr+str;
  i:=Length(comstr);
  if i>255 then Delete(comstr,1,i-240);
  usbTrigger:=True;
end;


procedure mInterruptEvent6(mBuffer:pbytearray );stdcall;
var
  mlength,mIndex: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
begin
  mlength:=mBuffer[0];
  mIndex:=6;
  CH375ReadData(mIndex,@buff,@mlength);
  str:='';
  for i:=0 to mlength-1 do
    str:=str+char(buff[i]);
  comstr:=comstr+str;
  i:=Length(comstr);
  if i>255 then Delete(comstr,1,i-240);
  usbTrigger:=True;
end;

procedure mInterruptEvent7(mBuffer:pbytearray );stdcall;
var
  mlength,mIndex: cardinal;
  i: Integer;
  str: string;
  buff: array[0..$FF] of Byte;
begin
  mlength:=mBuffer[0];
  mIndex:=7;
  CH375ReadData(mIndex,@buff,@mlength);
  str:='';
  for i:=0 to mlength-1 do
    str:=str+char(buff[i]);
  comstr:=comstr+str;
  i:=Length(comstr);
  if i>255 then Delete(comstr,1,i-240);
  usbTrigger:=True;
end;


procedure mCallInt(const devno: Integer) ;
var
  mm: procedure(mbuffer:pbytearray);stdcall;//TiIntRoutine;
  x:boolean;
begin
  if devno=0 then
    mm:=mInterruptEvent0
  else if devno=1 then
    mm:=mInterruptEvent1
  else if devno=2 then
    mm:=mInterruptEvent2
  else if devno=3 then
    mm:=mInterruptEvent3
  else if devno=4 then
    mm:=mInterruptEvent4
  else if devno=5 then
    mm:=mInterruptEvent5
  else if devno=6 then
    mm:=mInterruptEvent6
  else if devno=7 then
    mm:=mInterruptEvent7
  else
    Exit;

  x:= CH375SetIntRoutine(devno,mm);    //жӳ
  If x =false Then
  begin
    Showmessage(''+IntToStr(devno)+'USB豸޷ж');
    Exit;
  End;
end;
}

procedure OpenUsbdev;
var
  mOpen,i: Integer;
  buf: array[0..128] of Byte;
  l: Cardinal;
begin
  for i:=0 to MAXUSBCOUNT-1 do
  begin
    CH375CloseDevice(i);
    devid[i]:=0;
  end;
  UsbdevCount:=0;
  for i:=0 to MAXUSBCOUNT-1 do
  begin
    Application.ProcessMessages;
    mOpen := CH375OpenDevice(i);
    if mOpen = -1 then
    begin
      sleep(1000);
      mOpen := CH375OpenDevice(i);
      if mOpen = -1 then
        Exit;
    end;
    CH375SetTimeout(i,150,150);
    buf[0]:=1; buf[1]:=$DA; l:=2;
    CH375WriteData(i,@buf,@l);
    l:=10;
    if CH375readData(i,@buf,@l) then begin
      devid[i]:=buf[7];
    end
    else begin
      CH375ResetDevice(i);
      sleep(200);
      buf[0]:=1; buf[1]:=$DA; l:=2;
      CH375WriteData(i,@buf,@l);
      l:=10;
      if CH375readData(i,@buf,@l) then begin
        devid[i]:=buf[7];
      end
    end;
    CH375SetTimeout(i,500,500);
    mCallInt(i) ;
    UsbdevCount:=UsbdevCount+1;
  end;
end;


function TTeleComport.SetupPort: Boolean;
var
  str: string;
begin
  str:=Port;
  Result:=DoComPortSetup(str,Ateleobj);
  if Result then begin
    Port:=str;
  end;
end;

function TTeleComport.SetupPorts(var ports: String): Boolean;
var
  str: string;
begin
  str:=Port;
  Result:=DoComPortSetup(str,Ateleobj);
  if Result then begin
    ports:=str;
  end;
end;


  function IsDigit(const str: string): Boolean;
  const
    ds=['0'..'9'];
  var
    i: Byte;
  begin
    Result:=False;
    for i:=1 to Length(str) do
      if not (str[i] in ds) then Exit;
    Result:=str<>'';
  end;


{
function TTeleComport.ShowTeleNo: Boolean;

  function fdstrtod(ds: string): TDateTime;
  var
    yy,mm,dd,hh,nn: Word;
  begin
    Result:=Now;
    if not IsDigit(ds) then Exit;//mmddhhnn
    yy:=YearOf(Result);
    mm:=StrToInt(Copy(ds,1,2));
    dd:=MonthOf(Result);
    if (mm=12) and (dd=1) then yy:=yy-1
    else if (mm=1) and (dd=12) then yy:=yy+1;
    Delete(ds,1,2);
    dd:=StrToInt(Copy(ds,1,2));
    Delete(ds,1,2);
    hh:=StrToInt(Copy(ds,1,2));
    Delete(ds,1,2);
    nn:=StrToInt(Copy(ds,1,2));
    if isValidDateTime(yy,mm,dd,hh,nn,0,0) then
      Result:=encodeDateTime(yy,mm,dd,hh,nn,0,0);
  end;

var
  str,pno,dno: string;
  n,l,i,k: integer;
  bb: Byte;
  isok: Boolean;
  stp: string;
//  ps,pa: Integer;
begin
  Result:=False;
  stp:=comstr;
  n:=StartPos(comstr);
  if n=0 then Exit;
  str:=copy(comstr,n+6,255);
  k:=n+6;
  l:=Length(str);
  if (l<8) then Exit;
  n:=ord(str[2]);//Ϣܳ
  if (l<(n+3)) then Exit;

  bb:=0;
  for i:=1 to n+2 do
    bb:=bb+ord(str[i]);
  bb:=0-bb;
  isok:= bb=ord(str[n+3]);
  str:=Copy(str,1,n+2);
  k:=k+n+3;
  comstr:=copy(comstr,k,255);
  pno:=''; dno:='';
  case str[1] of
    #$04:
    begin
      dno:=Copy(str,3,8);
      pno:=Copy(str,11,n-8);
    end;
    #$80:
    begin
      i:=pos(#$01,str);//ʱ
      if i>0 then begin  //get the date string
        n:=ord(str[i+1]);
        dno:=Copy(str,i+2,n);
      end;
      i:=pos(#$02,str);//ǵ绰
      if i>0 then begin
        str:=Copy(str,i+1,255);
        n:=ord(str[1]);
        pno:=copy(str,2,n);
      end
      else begin
        i:=pos(#$03,str);//V2.3׼
        if i>0 then begin
          str:=Copy(str,i+1,255);
          n:=ord(str[1]);
          pno:=copy(str,2,n);
        end
        else begin
          i:=pos(#$04,str);//V2.3׼ UNAVAILABLE  unavailable
          if i>0 then begin
            str:=Copy(str,i+1,255);
            n:=ord(str[1]);
            pno:=copy(str,2,n);
          end
        end;
      end;
    end;
  end;
  GetDevIDFrom(stp);

//  pa:=pos('@',stp);
//  ps:=pos('&',stp);
//  if pa>0 then begin
//    Fdevid:=copy(stp,ps+1,pa-ps-1);
//    n:=Length(Fdevid);
//    if n>3 then
//      Fdevid:='0';
//    if FDevid='255' then FDevid:='0';
//    FDevid:=FDevid+'-'+Copy(stp,pa+1,1);
//  end
//  else
//    FDevid:='0-1';

  if isok and (Length(pno)>0) then begin
      FTeleNo:=pno;
      FTeleTime:=fdstrtod(dno);
      if Assigned(FOnRead) then FOnRead(Self, FTeleNo, FTeleTime, FDevid);
      Result:=True;
  end
  else if IsDigit(pno) and (Length(pno)>3) then begin
      FTeleNo:=pno;
      FTeleTime:=fdstrtod(dno);
      if Assigned(FOnRead) then FOnRead(Self, FTeleNo, FTeleTime, FDevid);
  end;
end;
}


//function GetCIDString(var instr,tstr: string): Boolean;
//function divitemofstring(var instr,ostr: string):Boolean;
//  ostr:=Format('Date=%-8s Telno=%-20s Name=%-20s',[dstr,no,ns]);
function TTeleComport.ShowTeleNo: Boolean;

  function fdstrtod(ds: string): TDateTime;
  var
    yy,mm,dd,hh,nn: Word;
  begin
    Result:=Now;
    if not IsDigit(ds) then Exit;//mmddhhnn
    yy:=YearOf(Result);
    mm:=StrToInt(Copy(ds,1,2));
    dd:=MonthOf(Result);
    if (mm=12) and (dd=1) then yy:=yy-1
    else if (mm=1) and (dd=12) then yy:=yy+1;
    Delete(ds,1,2);
    dd:=StrToInt(Copy(ds,1,2));
    Delete(ds,1,2);
    hh:=StrToInt(Copy(ds,1,2));
    Delete(ds,1,2);
    nn:=StrToInt(Copy(ds,1,2));
    if isValidDateTime(yy,mm,dd,hh,nn,0,0) then
      Result:=encodeDateTime(yy,mm,dd,hh,nn,0,0);
  end;

var
//  str,pno,dno: string;
  pno: string;
  n,i: integer;
  bb: Byte;
  isok: Boolean;
  stp,ss: string;
//  ps,pa: Integer;
begin
  Result:=False;
  stp:=comstr;
  ss:='';
  if not GetCIDString(comstr,ss) then Exit;
  bb:=0;
  n:=Length(ss);
  for i:=1 to n-1 do
    bb:=bb+ord(ss[i]);
  bb:=0-bb;
  isok:= bb=ord(ss[n]);
  GetDevIDFrom(stp);
  if not divitemofstring(ss,pno) then Exit;
  if isok then begin
      FTeleNo:=Trim(Copy(pno,9,20));
      FTeleTime:=fdstrtod(Copy(pno,1,8));
      if Assigned(FOnRead) then FOnRead(Self, FTeleNo, FTeleTime, FDevid);
      Result:=True;
  end
  else  begin
      FTeleNo:=Trim(Copy(pno,9,20))+' err';
      FTeleTime:=fdstrtod(Copy(pno,1,8));
      if Assigned(FOnRead) then FOnRead(Self, FTeleNo, FTeleTime, FDevid);
  end;
end;






constructor TTeleComport.Create(Owner: TComponent);
begin
  isMultiThread:=true;
  inherited Create(Owner);
  Port:='COM1';
  BaudRate:=TBaudRate(7);  //br9600;
  DataBits:=TDataBits(3);
  StopBits:=TStopBits(0);
  hasflash:=False;
  FJDConnected:=False;
  Fiswavedev:=False;
//  FUsbTeleThread:=nil;
//  FWindowHandle:=AllocateHWnd(UserData);
//  if not (csDesigning in ComponentState) then
//    InitDLLFunction;
  USB.OnUSBArrival:=OpenUSB;//avvi;
  USB.OnUSBRemove:=ReopenUSB;//CloseUSB;//avvi;
  Ateleobj:=self;
end;

destructor TTeleComport.Destroy;
var
  i: Integer;
begin
  if SameText(Port, 'USB') then
//    if deviceok then CH375CloseDevice(mIndex);
    for i:=0 to MAXUSBCOUNT-1 do
      CH375CloseDevice(i);
  DeallocateHWnd(FWindowHandle);
  inherited Destroy;
  Ateleobj:=nil;
end;

function iscompleterv(const rstr: string; var bstr: string): Boolean;
var
  i: Integer;
  n,b: Byte;
  str: string;
begin
  result:=False;
  bstr:='';
  if rstr='OK' then begin
    result:=True;
    bstr:=reda.ddata;
  end
  else begin
    i:=pos(PACKETHEAD,rstr);
    n:=Length(PACKETHEAD);
    if i=0 then Exit;
    str:=Copy(rstr,i+n,255);
    i:=Length(str);
    if (i<3) or ((i-2)<ord(str[1]))  then Exit;
    n:=ord(str[1]);
    b:=0;
    for i:=1 to n+1 do begin
      b:=b+ord(str[i]);
    end;
    b:=0-b;
    Result:=b=ord(str[n+2]);
    if Result then
      bstr:=Copy(str,2,n);
  end;
end;

function TTeleComport.EraseAll: Integer;
var
  lst,str,rlst: string;
  l,b: Byte;
begin
  result:=-1;
  l:=1;
  b:=0-(l+CM_EARSEALLDATA);

    if not connected then Exit;
    str:=PACKETSTART+char(1)+char(CM_EARSEALLDATA)+char(b);
    writestr(str);
    lst:='';
    rlst:='';
    for l:=0 to 20 do begin
      Application.ProcessMessages;
      sleep(10);
      readstr(str,InputCount);
      lst:=lst+str;
      if iscompleterv(lst,rlst) then
      begin
        Result:=0;
        break;
      end;
    end;
end;

function TTeleComport.LineStatus(const lineno: Integer=1): Integer;
var
  str: string;
  l,b,ln: Byte;
begin
  result:=-1;
  l:=2;
  if lineno<2 then
    ln:=0
  else
    ln:=lineno-1;

  b:=0-(l+CM_LINESTATUS+ln);
  str:=PACKETSTART+char(l)+char(CM_LINESTATUS)+char(ln)+char(b);
  restr:='';
  writestrtojd2000(str);
  str:='';
  if readfromjd2000(str)=0 then
  begin
    Result:=-1;
    if (length(str)=2) and (str[1]=#0) then begin
      Result:=ord(str[2]);
    end;
  end;
end;

function TTeleComport.ReadDevID(var devid: Integer): Integer;
var
  lst,str,rlst: string;
  l,b: Byte;
begin
  result:=-1;
  devid:=-1;
  if (Port='USB') then begin
    if (FJDUsbdevCount>0) then begin
      devid:=Integer(CH375DLL.devid[0]);
      Result:=0;
    end;
    Exit;
  end;
  l:=1;
  b:=0-(l+CM_READDEVID);

    if not connected then Exit;
    str:=PACKETSTART+char(1)+char(CM_READDEVID)+char(b);
    restr:='';
    writestr(str);
    lst:='';
    rlst:='';
    for l:=0 to 20 do begin
      Application.ProcessMessages;
      sleep(5);
      if iscompleterv(restr,rlst) then
      begin
        Result:=0;
        restr:='';
        break;
      end;
    end;
  if Result=0 then begin
    Result:=-1;
    if (length(rlst)=2) and (rlst[1]=#0 )then begin
      devid:=ord(rlst[2]);
      Result:=0;
    end;
  end;
end;

function TTeleComport.RecordsCount: Integer;
var
  lst,str,rlst: string;
  l,b: Byte;
begin
  result:=-1;
  l:=1;
  b:=0-(l+CM_NEWRECORDERCOUNT);

    if not connected then Exit;
    str:=PACKETSTART+char(1)+char(CM_NEWRECORDERCOUNT)+char(b);
    writestr(str);
    lst:='';
    rlst:='';
    for l:=0 to 20 do begin
      Application.ProcessMessages;
      sleep(10);
      readstr(str,InputCount);
      lst:=lst+str;
      if iscompleterv(lst,rlst) then
      begin
        Result:=0;
        break;
      end;
    end;

  if Result=0 then begin
    Result:=-1;
    if (length(rlst)=3) and (rlst[1]=#0) then begin
      Result:=ord(rlst[2])*255+ord(rlst[3]);
    end;
  end;
end;

function TTeleComport.ReadDevVer(var dver: string): Integer;
var
  lst,str,rlst: string;
  l,b: Byte;
begin
  result:=-1;
  dver:='';
  l:=1;
  b:=0-(l+CM_READVER);

    if not connected then Exit;
    str:=PACKETSTART+char(1)+char(CM_READVER)+char(b);
    writestr(str);
    lst:='';
    rlst:='';
    for l:=0 to 20 do begin
      Application.ProcessMessages;
      sleep(10);
      readstr(str,InputCount);
      lst:=lst+str;
      if iscompleterv(lst,rlst) then
      begin
        Result:=0;
        break;
      end;
    end;

  if Result=0 then begin
    Result:=-1;
    if rlst[1]=#0 then begin
      Result:=0;
      dver:=Copy(rlst,3,255);
    end;
  end;
end;

function TTeleComport.ReadAllRecords: Integer;
var
  lst,str,rlst: string;
  l,b: Byte;
  i,n: Integer;
begin
  result:=-1;
  l:=1;
  b:=0-(l+CM_READNEWRECORDER);

    if not Connected then Exit;
    str:=PACKETSTART+char(1)+char(CM_READNEWRECORDER)+char(b);
    writestr(str);
    lst:='';
    rlst:='';
    n:=0;
    for i:=0 to 20000 do begin
      Application.ProcessMessages;
      sleep(20);
      readstr(str,InputCount);
      lst:=lst+str;
      comstr:=comstr+str;
      if ShowTeleNo then inc(n);
      if iscompleterv(lst,rlst) then
      begin
        Result:=0;
        break;
      end;
      if Length(comstr)>255 then comstr:=copy(comstr,200,1024);
      if Length(rlst)>255 then rlst:=copy(rlst,200,1024);
      if (i>50) and (str='') then break;
    end;

  if Result=0 then begin
    Result:=-1;
    if rlst[1]=#0 then begin
      Result:=n;
    end;
  end;
end;


function TTeleComport.Dialup(const telno: string): Integer;
var
  lst,str,rlst: string;
  l,b: Byte;
  i: Integer;
begin
  result:=-1;
  if telno='' then Exit;
  l:=Length(telno)+1;
  b:=l+CM_DIALUP;
  for i:=1 to l-1 do
    b:=b+ord(telno[i]);
  b:=0-b;

    if not connected then Exit;
    str:=PACKETSTART+char(l)+char(CM_DIALUP)+telno+char(b);
    writestr(str);
    lst:='';
    rlst:='';
    for i:=0 to 100 do begin
      Application.ProcessMessages;
      sleep(50);
      readstr(str,InputCount);
      lst:=lst+str;
      if iscompleterv(lst,rlst) then
      begin
        Result:=0;
        break;
      end;
    end;

  if Result=0 then begin
    Result:=-1;
    if rlst[1]=#0 then begin
      Result:=0;
    end;
  end;
end;

function TTeleComport.Dialupchanl(const telno: string; chanl:Integer=1): Integer;
var
  str: string;
  l,b: Byte;
  i: Integer;
begin
  result:=-1;
  if telno='' then Exit;
  str:=IntToStr(chanl)+telno;
  l:=Length(str)+1;
  b:=l+CM_DIALUPCHANL;
  for i:=1 to l-1 do
    b:=b+ord(str[i]);
  b:=0-b;
  str:=PACKETSTART+char(l)+char(CM_DIALUPCHANL)+str+char(b);
  writestrtojd2000(str);

  str:='';
  if readfromjd2000(str)=0 then
  begin
    Result:=-1;
    if str[1]=#0 then begin
      Result:=0;
    end;
  end;
end;



procedure TTeleComport.ReadAllWhenOpen;
var
  i: Integer;
begin
  i:=RecordsCount;
  hasflash:= i>=0;
  if i>0 then
    ReadAllRecords;
end;

procedure TTeleComport.ackpack;
var
  stt: string;
  n,l: Integer;
  bb: Byte;
begin
  stt:=lastst;
  n:=StartPos(stt);
  if n=0 then Exit;
  Delete(stt, 1, n-1);
  Delete(stt, 1, 6);
  l:=Length(stt);
  if (l<8) then Exit;
  n:=ord(stt[2]);//Ϣܳ
  if (l<(n+3)) then Exit;
  lastst:=Copy(lastst,n+4,255);
  bb:=1+DATARESPONSE;
  bb:=0-bb;

      if not connected then Exit;
      WriteStr(PACKETSTART+char(1)+char(DATARESPONSE)+char(bb));
end;


procedure TTeleComport.DoRxChar(Count: Integer);
var
  str,s: string;
  i: SmallInt;
  tt: TDateTime;

  procedure DealStr;
  var
    l: Integer;
  begin
    if hasflash then begin
      lastst:=lastst+str;
      ackpack;
      l:=Length(lastst);
      if l>255 then Delete(lastst,1,l-240);
    end;
    l:=Length(comstr);
    ShowTeleNo;
    if l>255 then Delete(comstr,1,l-240);
  end;

  function hextostring(str: string): string;
  var
    i: Integer;
    s: string;
  begin
    Result:='';
    s:=Trim(str);
    i:=pos(' ',s);
    while (i>0) do begin
      Result:=Result+char(strToInt('$'+Copy(s,1,i-1)));
      s:=Trim(Copy(s,i+1,1024));
      i:=pos(' ',s);
    end;
    if s>'' then
      Result:=Result+char(strToInt('$'+s));
  end;

  procedure ShowTelno;
  var
    i: Integer;
  begin
    i:=pos(#13,reda.ddata);
    if (i>0)  then begin
      FTeleNo:=Copy(reda.ddata,3,i-2);
      FTeleTime:=tt;
      Fdevid:=FportID+'-'+Copy(reda.ddata,2,1);
      if Assigned(FOnRead) then FOnRead(Self, FTeleNo, FTeleTime, FDevid);
    end;
  end;

  procedure DTMF_inkey;
  var
    Key: Char;
  begin
    if Length(reda.ddata)<3 then Exit;
    Key:=reda.ddata[3];
    Fdevid:=FportID+'-'+reda.ddata[2];
    if Assigned(FOnKeyPress) then
      FOnKeyPress(Self, Key, FDevid);
    //case reda.ddata[3] of
    //  'R':  //
    //    devicerings;
    //  'T':  //ժ
    //    deviceTakeup;
    //  'H':  //һ
    //    deviceHandup;
    //  else begin
    //    memo1.Lines.Add(reda.ddata[3]);
    //    dialno:=dialno+reda.ddata[3];
    //  end;
    //end;
  end;

  procedure DoWavein;
  begin
    Fdevid:=FportID+'-'+reda.ddata[2];
    if Assigned(FOnWavein) then
      FOnWavein(Self,reda.ddata,FDevid);
    //if recstart then begin
    //  write(fp,reda.ddata);
    //  Byteins:=Byteins+Length(reda.ddata);
    //end;
  end;

begin
  if SameText(Port, 'USB') then Exit;
  inherited;
  readstr(str,Count);
  if str='' then Exit;
  tt:=now;

  if iswavedev then  //ܵݰʽ
  begin
    if (tt-LastComTime)*86400>1 then chsta:=0;
    LastComTime:=tt;
    for i:=1 to Length(str) do
    begin
      getachpack(str[i]);
      if chsta>=8 then begin
         if chsta=9 then begin
           chsta:=0;
           case reda.dtype of
           #$A0:  //绰
            ShowTelno;
           #$A1:  //DTMF
            DTMF_inkey;
           #$A2:  //Ƶ
            DoWavein;
           else
            restr:='OK';
           end;
         end;
      end;
    end;
  end
  else begin
    s:='';
    for i:=1 to Length(str) do
    begin
      case str[i] of
      '@','%': s:=s+'&1'+str[i];
      else
        s:=s+str[i];
      end;
    end;

    if (tt-LastComTime)*86400>1 then
    begin
      comstr:=s;
      restr:=s;
    end
    else begin
      comstr:=comstr+s;
      restr:=restr+s;
    end;
    LastComTime:=tt;
    DoPressKey;
    DealStr;
    if Length(restr)>255 then restr:=Copy(restr,100,255);
  end;
end;

{
procedure TTeleComport.avvi(sender: TObject);
begin
  if not SameText(Port, 'USB') then Exit;
  OpenUsbdev;
  if deviceok then begin
    FConnected:=True;
    if Assigned(FOnOpen) then FOnOpen(Self);
  end
  else begin
    FConnected:=False;
    if Assigned(FOnClose) then FOnClose(Self);
  end;
end;
}

procedure TTeleComport.Close;
begin
  if SameText(Port, 'USB') then CloseUSB(Self)
  else begin
    inherited;
    FJDConnected:=Connected;
    if Assigned(FOnClose) then FOnClose(Self);
  end;
end;

procedure TTeleComport.Open;
var
  str: string;
begin
  if (Port='') then
    if DoComPortSetup(str,Ateleobj)
      then Port:=str
      else Exit;
  FportID:='0';
  if SameText(Port, 'USB') then
    OpenUSB(Self)
  else begin
    str:=UpperCase(Port);
    if pos('COM',str)>1 then
    begin
      Port:=Copy(str,2,4);
      if str[1]='1' then
        baudrate:=br115200;
    end;
    inherited;
    FportID:=Copy(port,length(port),1);
    FJDConnected:=Connected;
    if Assigned(FOnOpen) then
    begin
      FOnOpen(Self);
    end;
  end;
end;

procedure TTeleComport.OpenUSB(Sender: TObject);
begin
  if SameText(Port, 'USB') then begin
    OpenUsbdev;
    FJDConnected:=usbdevcount>0;
    FJDUsbdevcount:=usbdevcount;
  end
  else begin
    if (not connected) and  PortExists(port) then
      Open;
  end;
  if FJDConnected then begin
//    if not Assigned(FUsbTeleThread) then
//      FUsbTeleThread := TUsbTeleThread.Create(FWindowHandle);
    if Assigned(FOnOpen) then FOnOpen(Self);
  end;

end;

procedure TTeleComport.CloseUSB(Sender: TObject);
var
  i: Integer;
begin
  for i:=0 to MAXUSBCOUNT-1 do
    CH375CloseDevice(i);
  usbdevcount:=0;
  FJDUsbdevCount:=0;
  if Assigned(FOnClose) then FOnClose(Self);
end;


procedure TTeleComport.ReopenUSB(Sender: TObject);
begin
  if SameText(Port, 'USB') then
  begin
    Close;
    OpenUsbdev;
    FJDConnected:=usbdevcount>0;
    FJDUsbdevcount:=usbdevcount;
  end
  else begin
    if connected and (not PortExists(port)) then
    begin
      Close;
//      connected:=False;
    end;
  end;
end;


procedure TTeleComport.SetJDConnected(const Value: Boolean);
begin
  if not ((csDesigning in ComponentState) or (csLoading in ComponentState)) then
  begin
    if Value <> FJDConnected then
      if Value then
        Open
      else
        Close;
  end;
  //else
    FJDConnected := Value;
end;

//procedure TTeleComport.Setiswavedev(const Value: Boolean);
//begin
//  if not ((csDesigning in ComponentState) or (csLoading in ComponentState)) then
//    iswavedev := Value;
//end;


{ TUsbTeleThread }
{
constructor TUsbTeleThread.Create(AHandle: THandle);
begin
  inherited Create(False);
  hMsg:=AHandle;
end;

procedure TUsbTeleThread.Execute;
begin
  while not Terminated do begin
    if usbTrigger then begin
      SendMessage(hMsg, WM_USER, 0, 111);
      usbTrigger:=False;
    end;
    Application.ProcessMessages;
  end;
end;

procedure TTeleComport.UserData(var Msg: TMessage);
var
  pa: SmallInt;

  procedure DoPressKey;
  var
    Key: Char;
    ps: SmallInt;
  begin
    if Length(comstr)<pa+2 then Exit;
    Key:=comstr[pa+2];
    ps:=pos('&', comstr);
    Fdevid:=copy(comstr,ps+1,pa-ps-1);
    if (Length(Fdevid)>3) or (FDevid='255') then
      FDevid:='0';
    FDevid:=FDevid+'-'+Copy(comstr,pa+1,1);
    if Assigned(FOnKeyPress) then
      FOnKeyPress(Self, Key, FDevid);
    Delete(comstr, 1, pa+2);
  end;
begin
  case Msg.LParam of
    111:
    begin
      pa:=Pos('%', comstr);
      if pa>0
        then DoPressKey
        else ShowTeleNo;
    end;
  end;
end;
}

procedure TTeleComport.DoTelerportEvent;
{
var
  pa: SmallInt;
  procedure DoPressKey;
  var
    Key: Char;
    ps: SmallInt;
  begin
    if Length(comstr)<pa+2 then Exit;
    Key:=comstr[pa+2];
    ps:=pos('&', comstr);
    Fdevid:=copy(comstr,ps+1,pa-ps-1);
    if (Length(Fdevid)>3) or (FDevid='255') then
      FDevid:='0';
    FDevid:=FDevid+'-'+Copy(comstr,pa+1,1);
    if Assigned(FOnKeyPress) then
      FOnKeyPress(Self, Key, FDevid);
    Delete(comstr, 1, pa+2);
  end;
}
{
  procedure DoPressKey;
  var
    Key: Char;
  begin
    pa:=pos('%',comstr);
    while pa>0 do begin
      if Length(comstr)<pa+2 then Exit;
      Key:=comstr[pa+2];
      FDevid:='1-'+Copy(comstr,pa+1,1);
      if Assigned(FOnKeyPress) then
        FOnKeyPress(Self, Key, FDevid);
      Delete(comstr, pa, 3);
      pa:=pos('%',comstr);
    end;
  end;
}
begin
  DoPressKey;
  ShowTeleNo;
end;

procedure TTeleComport.GetDevIDFrom(const cst: string);
var
  ps: Integer;
begin
  ps:=pos('&',cst);
  if (ps>0) and (Length(cst)>(ps+2)) then
    Fdevid:=copy(cst,ps+1,1)+'-'+copy(cst,ps+3,1)
  else
    FDevid:='0-0';
end;

procedure TTeleComport.DoPressKey;
var
  Key: Char;
  i: Integer;
begin
  i:=pos('%',comstr);
  while (i>2) and (comstr[i-2]='&') do begin
    if Length(comstr)<i+2 then Exit;
    Key:=comstr[i+2];
    GetDevIDFrom(comstr);
    if Assigned(FOnKeyPress) then
      FOnKeyPress(Self, Key, FDevid);
    Delete(comstr,i-2,5);
    i:=pos('%',comstr);
  end;
end;

procedure TTeleComport.writestrtojd2000(const st: string);
var
  buf: array[0..128] of char;
  l,idx: cardinal;
  s: string;
  n: Integer;
begin
  if Port='USB' then begin
    if UsbdevCount=0 then Exit;
    n:=pos(#$FF#$55#$AA#$FF,st);
    if n=0 then
      s:=st
    else begin
      s:=Copy(st,n+4,255);
      if s>'' then
        s:=Copy(s,1,ord(s[1])+1);
    end;
    strPCopy(buf,s);
    l:=Length(s);
    idx:=0;
    CH375WriteData(idx,@buf,@l);
  end
  else begin
    if not connected then Exit;
    writestr(st);
  end;
end;


function TTeleComport.readfromjd2000(var st: string): Integer;
var
  buf: array[0..128] of char;
  i,ll: cardinal;
//  s: string;
  lst,rlst: string;

begin
  lst:='';
  rlst:='';
  Result:=-1;
  if port='USB' then begin
    if UsbdevCount=0 then Exit;
    i:=0;
    ll:=64;
    if CH375readData(i,@buf,@ll) then begin
      if ll=0 then Exit;
      for i:=0 to ll-1 do
        lst:=lst+char(buf[i]);
      if iscompleterv(lst,rlst) then
        Result:=0;
    end
    else
      Exit;
  end
  else  begin
    if not connected then Exit;
    if iswavedev then begin
      for i:=0 to 200 do begin
        Application.ProcessMessages;
        sleep(5);
        if restr='OK' then
        begin
          Result:=0;
          rlst:=reda.dtype+reda.ddata;
          break;
        end;
      end;
    end
    else begin
      for i:=0 to 100 do begin
        Application.ProcessMessages;
        sleep(50);
        if iscompleterv(restr,rlst) then

        begin
          Result:=0;
          break;
        end;
      end;
    end;
  end;
  st:=rlst;
end;



procedure TTeleComport.SetHandup(const ishandup: Integer; const chanl: Integer=1);
var
  s: string;
begin
  if (chanl<0) or (chanl>4)  then Exit;
  if isHandup=0 then
    s:=#$D4#0
  else
    s:=#$D4#1;


  if (chanl=0) then
    s:=s+#0
  else
    s:=s+char(chanl-1);
  s:=gstcommstr(s);
  writestrtojd2000(s);
end;

function TTeleComport.ReadSysTelNo(const syskeyno: Integer=1): string;
var
  s: string;
  t1,t2: DWORD;
begin
  Result:='';
  if (syskeyno<0) or (syskeyno>4)  then Exit;
  s:=#$D5+char(syskeyno);
  s:=gstcommstr(s);
  restr:='';
  writestrtojd2000(s);
  t1:=GetTickCount();
  while True do begin
    Application.ProcessMessages;
    if pos(#13,restr)>0 then begin
      Result:=restr;
      Break;
    end;
    t2:=GetTickCount();
    if (t2-t1)>=50 then Break;
  end;
end;

function TTeleComport.SetSysTelNo(const teleno: string;
  const syskeyno: Integer; const chanl: Integer=1): Integer;
var
  s: string;
begin
  Result:=-1;
  if (chanl<0) or (chanl>4)  then Exit;
  if (syskeyno<0) or (syskeyno>4)  then Exit;
  if length(teleno)<1  then Exit;

  s:=#$D6+char(syskeyno+$30)+char(chanl+$30)+teleno;
  s:=gstcommstr(s);
  restr:='';
  writestrtojd2000(s);
  if getreturnsta(10) then
    Result:=0;
end;

procedure TTeleComport.Startwavein(const chanl: Integer);
var
  s: string;
begin
  if (chanl<0) or (chanl>4)  then Exit;
  s:=#$CB#$01+char(chanl);
  s:=gstcommstr(s);
  writestrtojd2000(s);
end;

procedure TTeleComport.Stopwavein(const chanl: Integer);
var
  s: string;
begin
  if (chanl<0) or (chanl>4)  then Exit;
  s:=#$CB#$00+char(chanl);
  s:=gstcommstr(s);
  writestrtojd2000(s);
end;

initialization

  //SetLength(mProc, MAXUSBCOUNT);

finalization

  //SetLength(mProc, 0);

end.


