unit TelePortSet;

{$define COMPONENTALONE}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, TranslateLanguage, TeleComportUnit,
  CPort,Registry;

type
  TfrmComPortSetup = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    LabeledEdit1: TLabeledEdit;
    GroupBox1: TGroupBox;
    procedure RadioGroup1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
    portno: Integer;
    TeleComport1: TTeleComport;
  public
    { Public declarations }
    bQuit: Boolean;
  end;

function DoComPortSetup(var Port: string; compt: TTeleComport): Boolean;


implementation

{$R *.dfm}

{$ifdef COMPONENTALONE}
procedure GetAllComPort(ts: TStrings);
var
  rt: TRegistry;
  i: Integer;
begin
  rt:=TRegistry.Create;
  with rt do
  try
    RootKey:=HKEY_LOCAL_MACHINE;
    OpenKey('HARDWARE\DEVICEMAP\SERIALCOMM',False);
    GetValueNames(ts);
    for i:=0 to ts.Count-1 do
      ts[i]:=ReadString(ts[i]);
  finally
    Free;
  end;
end;
{$endif}


function DoComPortSetup(var Port: string; compt: TTeleComport): Boolean;
var
  i: SmallInt;
  isf: Boolean;
  s,s1,bs: string;
begin
  with TfrmComPortSetup.Create(nil) do
  try
      isf:=False;
      TeleComport1:=compt;
      with GroupBox1 do begin
        for i:=0 to ControlCount-1 do
        begin
          if Controls[i] is TCheckBox then
          with (Controls[i]as TCheckBox) do begin
            Checked:=(Port=Caption);
            if Checked then isf:=True;
          end;
        end;
      end;

      if not isf then
      with GroupBox1 do begin
        for i:=0 to ControlCount-1 do
        begin
          if Controls[i] is TCheckBox then
          with (Controls[i]as TCheckBox) do begin
            if Caption='' then
            begin
              Checked:=True;
              LabeledEdit1.Visible:=True;
              LabeledEdit1.Text:=Port;
              break;
            end;
          end;
        end;
      end;

      Result:=(ShowModal=mrOK);
      if Result then
      with GroupBox1 do begin
        s:='';
        for i:=0 to ControlCount-1 do
        begin
          if Controls[i] is TCheckBox then
          with (Controls[i]as TCheckBox) do begin
            if Checked then begin
              if i=(ControlCount-1) then
                s1:=LabeledEdit1.Text
              else
                s1:=Caption;
              if tag=1 then bs:='1' else bs:='';

              if s='' then
                s:=bs+s1
              else
                s:=s+','+bs+s1;
            end;
          end;
        end;
        Port:=s;
      end;
  finally
    Free;
  end;
end;

procedure TfrmComPortSetup.RadioGroup1Click(Sender: TObject);
begin
//  LabeledEdit1.Visible:=(RadioGroup1.ItemIndex=5);
//  BitBtn1.Enabled:=(RadioGroup1.ItemIndex>=0);
end;

procedure TfrmComPortSetup.BitBtn3Click(Sender: TObject);
var
  i: SmallInt;
  devid: Integer;
//  dver,s: string;
  s: string;
  cb: TCheckBox;
  obrate: TBaudrate;
  ocrate: Integer;
begin

  bQuit:=False;

  with TeleComport1 do
  begin
    obrate:=Baudrate;
    ocrate:=CustomBaudRate;
  end;

  for i:=0 to Groupbox1.ControlCount-1 do
    with TeleComport1 do
    try
      obrate:=Baudrate;
      ocrate:=CustomBaudRate;
      Close;
      cb:=(Groupbox1.Controls[i] as  TCheckbox);
      cb.Checked:=False;
      s:=cb.Caption;
      if s='' then
      begin
        Continue;
        s:=LabeledEdit1.Text;
      end;
      Port:=s;
      Open;
      Application.ProcessMessages;

      Baudrate:=br9600;
      if ReadDevID(devid)=0 then begin  //Գɹ
          JDConnected:=False;
          BitBtn1.Enabled:=True;
          ShowMessage(Port+' is OK. DevID is '+IntToStr(devid));
          cb.Checked:=True;
          cb.Tag:=0;
      end
      else begin
        Baudrate:=br115200;
        if ReadDevID(devid)=0 then begin  //Գɹ
          JDConnected:=False;
          BitBtn1.Enabled:=True;
          ShowMessage(Port+' is OK. DevID is '+IntToStr(devid)+'  Baudrate=115200');
          cb.Checked:=True;
          cb.Tag:=1;
        end;
      end;
    except
    end;
  with TeleComport1 do
  begin
    Baudrate:=obrate;
    CustomBaudRate:=ocrate;
  end;

end;

procedure TfrmComPortSetup.BitBtn2Click(Sender: TObject);
begin
  bQuit:=True;
end;

procedure TfrmComPortSetup.FormCreate(Sender: TObject);
var
  ts: TStrings;
  i,n: Integer;
  x,y,nl,w: Integer;
begin
  ts:=TStringList.Create;
  try
{$ifdef COMPONENTALONE}
    GetAllComPort(ts);
{$else}
    ts.Insert(0,'USB');
{$endif}
    ts.Add('');
    portno:=ts.Count;
    nl:=(portno div 4) +1;
    if (portno mod 4)>0 then inc(nl);
    nl:=(GroupBox1.Height div nl);

    w:=(GroupBox1.Width-20) div 4;
    x:=10;y:=nl-9; n:=0;
    for i:=0 to portno-1 do begin
      with TCheckBox .Create(GroupBox1) do
      begin
        Parent:=GroupBox1;
        Visible:=True;
        Name:='CheckBox'+IntToStr(i+1);
        Caption:=ts[i];
        OnClick:=CheckBox1Click;
        width:=w;
        Left:=x;
        Top:=y;
        x:=x+60;
        inc(n);
        if n=4 then begin
          n:=0;
          x:=10;
          y:=y+nl;
        end;
      end;
    end;
  finally
    ts.Free;
  end;
end;

procedure TfrmComPortSetup.CheckBox1Click(Sender: TObject);
begin
  with (Sender as TCheckBox) do
    if Caption='' then
      LabeledEdit1.Visible:=Checked;
end;

end.
